<?php

$ec=0;

/* Aufrufe der Binärdatei "unchm" */
function lschm($chmfile) {
 global $ec;
 unset($arr);
 exec("./unchm '$chmfile'",$arr,$ec);
 return $arr;
}

function unchm($chmfile,$internalfile) {
 global $ec;
 passthru("./unchm '$chmfile' '$internalfile'",$ec);
}

function getchm($chmfile,$internalfile) {
 return `./unchm '$chmfile' '$internalfile'`;
}

$DefaultUser="heha";	// falls Benutzername weggelassen wird (kürzere URL)

// extrahiert alle Microsoft-Objekt-Parameter zum Returnwert
function objectparams($node) {
 $item=array();
 foreach($node->childNodes as $param) {
  if ($param->nodeName!="param") continue;
  $params=array();				// nachher sollte es stets zwei Indizes geben, 'name' und 'value'
  foreach($param->attributes as $attr) $params[$attr->name]=$attr->value;	// aufsammeln
  $item[$params['name']]=$params['value'];	// ImageNumber: Symbol ändern, WindowName: Zielfenster, Merge: <chmfile>::/<hhcfile>
 }						// Kann Präfix "ms-its:SubHelpSubject2.chm::/" enthalten!?
 return $item;
}
// Inhaltsverzeichnis: Mit Rekursion
// Jeder Knoten in $list hat 2..3 Elemente: Immer "Name", meistens "Value" (= URL) und manchmal "sub" (= Unterliste)
function recurse_hhc($ul) {
 $list=array();
 foreach($ul->childNodes as $li) {
  if ($li->nodeName!="li") continue;
  foreach($li->childNodes as $node) {
   switch ($node->nodeName) {
    case "ul": $item['sub']=recurse_hhc($node); break;	// Untergeordnete Liste einhängen
    case "object": $item=objectparams($node); break;
   }
  }
  $list[]=$item;
 }
 return $list;
}
// Stichworte: Ohne Rekursion, nur 2 Ebenen für gleiche Stichworte
function generate_hhk($ul) {
 $list=array();
 foreach($ul->childNodes as $li) {
  if ($li->nodeName!="li") continue;
  foreach($li->childNodes as $node) {
   switch ($node->nodeName) {
    case "object": $item=objectparams($node); break;
   }
  }
  $found=false;
  foreach($list as &$i) {
   if ($i['Name']==$item['Name']) {	// Gleicher Name? Kein doppelter Eintrag!
    if (!array_key_exists('sub',$i)) {
     $n['Name']=basename($i['Local']);	// TODO: Titel einsetzen! (Woher nehmen?? Dazu muss bspw. die hhc-Datei geparst werden)
     $n['Local']=$i['Local'];
     $i['sub'][]=$n;	// sub-Array erzeugen und initialisieren
     unset($n);
     unset($i['Local']);
    }
    $item['Name']=basename($item['Local']);
    $i[sub][]=$item;	// an sub-Array anhängen
    $found=true;
    break;
   }
  }
  if (!$found) $list[]=$item;
 }
 function cmp($a,$b) {return strcmp($a["Name"],$b["Name"]);}
 usort($list,"cmp");
 return $list;
}

$depth=0;
$subnr=0;

// fehlt noch die Auswertung des Highlight-Paramters
function out_tree($list) {
 global $depth,$subnr;
 echo str_repeat(" ",$depth++)."<ul>\n";
 foreach($list as $item) {
  echo str_repeat(" ",$depth)."<li>";
  if ($item['sub']) echo "<input type=checkbox tabindex=-1>";
  if ($item['Local']) echo "<a href='{$item['Local']}'>{$item['Name']}</a>";
  else echo "<a nohref>{$item['Name']}</a>";
  echo "\n";
  if ($item['sub']) out_tree($item['sub']);
 }
 echo str_repeat(" ",--$depth)."</ul>\n";
}

function systemfile($file) {
 $data=getchm($file,'#SYSTEM');
 $b=unpack("Vversion",$data);
 $data=substr($data,4);	// Version übergehen
 while ($data) {
  $a=unpack("vcode/vlen",$data);
  $b[$a['code']]=substr($data,4,$a['len']);
  $data=substr($data,4+$a['len']);
 }
 $textidx=array(0,1,2,3,5,6,16);
 foreach($textidx as $idx) {
  $b[$idx]=trim($b[$idx]);
 }
 return $b;
}

// HHP-Datei ausspucken
function hhp($file) {
 $b=systemfile($file);
 echo "[OPTIONS]\n";
 $v=$b[11]? "Yes":"No";
 echo "Binary TOC=$v\n";
 $v=$b['version'];
 switch ($v) {
  case 2: $v="1.0"; break;
  case 3: $v="1.1"; break;
 }
 echo "Compatibility=$v\n";
 $v=$b[6];
 echo "Compiled file=$v.chm\n";
 $v=$b[0];
 echo "Contents file=$v\n";
 $v=$b[1];
 echo "Index file=$v\n";
 $v=$b[5];
 echo "Default Window=$v\n";
 $v=$b[2];
 echo "Default topic=$v\n";
 echo "Display compile progress=No\n";
 $c=unpack("Vlcid/Vdbcs/Vfts/Vklink/Valink",$b[4]);	// P (int64) geht nicht!
 $v=$c['fts']? "Yes":"No";
 echo "Full-text search=$v\n";
 switch ($c['lcid']) {
  case 0x0407: $v=" Deutsch (Deutschland)"; break;
  case 0x0409: $v=" English (US)"; break;
  default: $v=null;
 }
 if ($c['dbcs']) $v.=" DBCS";
 printf("Language=0x%X$v\n",$c['lcid']);
 $v=$b[3];
 echo "Title=$v\n";
 echo "\n";
 echo "[WINDOWS]\n";
 echo "*TODO*\n";
// echo "main=,"atmegax8.hhc","atmegax8.hhk","0.htm","0.htm",,,,,0x62520,,0x70384e,,,,,,,,\n";
 echo "\n";
 echo "[FILES]\n";
 echo "*TODO*\n";
}

// Datei nach Endung suchen (dies ist unsauber denn das Inhaltsverzeichnis steht in #SYSTEM)
function findfilebyext($file,$ext) {
 $lines=lschm($file);
 foreach($lines as $line) {
  $i=strpos($line,"\t/");
  if ($i && substr($line,-1)!='/') {
   $name=substr($line,$i+2);
   if (strtolower(substr($name,-4))==".".$ext) return $name;
  }
 }
 return null;
}
// Die *.hhp/*.hhk einlesen und den ersten <UL>-Tag als DOM-Baum liefern
function getdom($file,$trail) {
 $text=getchm($file,$trail);
 $dom=new DOMDocument();
 $dom->loadHTML($text);
 $uls=$dom->getElementsByTagName("ul");
 return $uls->item(0);
}
// Eine Liste der halbwegs in Reihenfolge liegenden Dateien erzeugen,
// ohne Dopplungen
function findfiles_hhc(&$list,$ul) {
 foreach($ul->childNodes as $li) {
  if ($li->nodeName!="li") continue;
  foreach($li->childNodes as $node) {
   switch ($node->nodeName) {
    case "ul": findfiles_hhc($list,$node); break;
    case "object":
    $item=objectparams($node);
    $url=$item['Local'];
    if (!$url) break;		// Kein Link
    $a=parse_url($url);
    if (!$a) break;		// Fehler
    if ($a['host']) break;	// Externer Link: Nicht einsortieren!
    $n=$a['path'];
    if (!$n) break;		// Pfad fehlt: Geht nicht!
    if (in_array($n,$list)) break; // Schon vorhanden: Nicht mehrfach!
    $list[]=$n;			// (Pfad+)Dateiname anfügen
    break;
   }
  }
 }
}

function error($msg) {
 header("Content-Type: text/plain; charset=utf-8");
 die($msg);
}

function nextfile($file,$trail,$dir) {
// 0. Von <trail> das lokale Ziel entfernen
 $n=parse_url($trail,PHP_URL_PATH);
 if (!$n) error("Pardon, hier fehlt ein Dateiname!");
// 1. Inhaltsverzeichnis laden
 $dirfile=findfilebyext($file,"hhc");
 if (!dirfile) error("Pardon, keine Funktion ohne Inhaltsverzeichnis!");
// 2. Baum in Dateinamensliste umwandeln
 $ul=getdom($file,$dirfile);
 $list=array();
 findfiles_hhc($list,$ul);
// 3. Dateiname in Liste suchen
 $len=count($list);
 $pos=array_search($n,$list);
 if ($pos===false) error("Pardon, „$n“ ist nicht im Inhaltsverzeichnis!");
 if ($len==1) error("Pardon, Inhaltsverzeichnis enthält nur diese eine Datei!");
// 4. Benachbartes Element liefern
 switch ($dir) {
  case "next": $dir=1; break;
  case "prev": $dir=-1; break;
 }
 $pos+=$dir;
 if ($pos<0) $pos+=$len;
 if ($pos>=$len) $pos-=$len;
 return $list[$pos];
}

function getreferer() {
 $url=$_SERVER['HTTP_REFERER'];	// kompletter String
 $i=strpos($url,".chm");
 if ($i===false) $i=strpos($info,".CHM/");
 if ($i===false) error("Ungültiges Skript-Argument! HTTP_REFERER muss .chm/ oder .CHM/ enthalten");
 return array('url'=>$url,'slash'=>$i+4);
}

// Linke Seite ausspucken
// TODO: Feststellen, ob Inhaltsverzeichnis / Index / Volltextsuche existiert
// TODO: Knöpfe funktionstüchtig machen und besser visualisieren
function LeftPane($info) {
 header("Content-Type: text/html; charset=utf-8");
 echo "<!DOCTYPE html>\n";
 echo "<html style='width:100%;height:100%'><head>\n";
//  echo "<base target=rechts>\n";
//  echo "<link rel=stylesheet href='root/treeview.css'>\n";
 echo "<script src='root/viewchm.js'></script>\n";
 echo "<style>input {border:2px outset;}</style>\n";
 echo "</head><body style='width:100%;height:100%;padding:0;margin:0;background:#DDD'>\n";
 echo "<table cellspacing=0 cellpadding=4 width=100% height=100%>\n";
 echo "<tr height=20><td nowrap>\n";
 echo "<a href='?hhc' target=innen tabindex=-1><button>Inhalt</button></a>\n";
 echo "<a href='?hhk' target=innen tabindex=-1><button>Index</button></a>\n";
// echo "<button>Suchen</button>\n";
 echo "<td align=right nowrap>\n";
 $dl=getreferer();
 $dl=str_replace("viewchm.php/","",substr($dl['url'],0,$dl['slash']));
 echo "<input type=image src='icons/dl24.gif' title='CHM-Datei herunterladen' onclick='ifp(\"$dl\")'>\n";
 echo "<input type=image src='icons/sync.gif' title='Finde im Verzeichnis' onclick='sync()'>\n";
 echo "<input type=image src='icons/prev.gif' title='Vorherige Seite' onclick='prev()'>\n";
 echo "<input type=image src='icons/next.gif' title='Nächste Seite' onclick='next()'>\n";
 echo "<tr height=100%><td align=center colspan=2 valign=top>\n";
 echo "<iframe name=innen src='?hhc' style='width:96%;height:99%;background:white;border:2px inset #DDD' onload='iframeload()'>\n";
 echo "</table>";
 echo "</body></html>\n";
}

function mimetype($filename) {
 $mime_types = array(
   'txt' => 'text/plain',
   'htm' => 'text/html',
   'html' => 'text/html',
   'php' => 'text/html',
   'css' => 'text/css',
   'js' => 'application/javascript',
   'json' => 'application/json',
   'xml' => 'application/xml',
   'swf' => 'application/x-shockwave-flash',
   'flv' => 'video/x-flv',
// images
   'png' => 'image/png',
   'jpe' => 'image/jpeg',
   'jpeg' => 'image/jpeg',
   'jpg' => 'image/jpeg',
   'gif' => 'image/gif',
   'bmp' => 'image/bmp',
   'ico' => 'image/vnd.microsoft.icon',
   'tiff' => 'image/tiff',
   'tif' => 'image/tiff',
   'svg' => 'image/svg+xml',
   'svgz' => 'image/svg+xml',
// archives
   'zip' => 'application/zip',
   'rar' => 'application/x-rar-compressed',
   'exe' => 'application/x-msdownload',
   'msi' => 'application/x-msdownload',
   'cab' => 'application/vnd.ms-cab-compressed',
// audio/video
   'mp3' => 'audio/mpeg',
   'qt' => 'video/quicktime',
   'mov' => 'video/quicktime',
// adobe
   'pdf' => 'application/pdf',
   'psd' => 'image/vnd.adobe.photoshop',
   'ai' => 'application/postscript',
   'eps' => 'application/postscript',
   'ps' => 'application/postscript',
// office
   'doc' => 'application/msword',
   'rtf' => 'application/rtf',
   'xls' => 'application/vnd.ms-excel',
   'ppt' => 'application/vnd.ms-powerpoint',
   'odt' => 'application/vnd.oasis.opendocument.text',
   'ods' => 'application/vnd.oasis.opendocument.spreadsheet',
 );
 $ext = strtolower(array_pop(explode('.',$filename)));
 if (array_key_exists($ext, $mime_types)) {
  return $mime_types[$ext];
 }elseif (function_exists('finfo_open')) {
  $finfo = finfo_open(FILEINFO_MIME);
  $mimetype = finfo_file($finfo, $filename);
  finfo_close($finfo);
  return $mimetype;
 }else return 'application/octet-stream';
}

$info=$_SERVER["PATH_INFO"];
$i=strpos($info,".chm/");		# Wo die Datei-Inhalte beginnen
if ($i===false) $i=strpos($info,".CHM/");
if ($i===false) error("Ungültiges Skript-Argument! PATH_INFO muss .chm/ oder .CHM/ enthalten!");
$trail=substr($info,$i+5);		# Wenn (trail), dann Datei auspacken!
$info=substr($info,0,$i+4);		# "/pfad/blabla.chm"
$file=$info;				# kommt mit führendem /
$file=$_SERVER['CONTEXT_DOCUMENT_ROOT'].$file;
parse_str($_SERVER['QUERY_STRING'],$query);
$val0=reset($query);
$key0=key($query);
$time=filemtime($file);
//header("Last-Modified: ".gmdate("D, d M Y H:i:s T",$time));	// andere Zeiten gibt's nicht

switch ($key0) {
 case "hhc":	// hhc parsen
 case "hhk": {	// hhk parsen
  if (!$trail) $trail=findfilebyext($file,$key0);	// HHC/HHK-Datei suchen
  if (!$trail) error("Kann Inhaltsverzeichnis nicht finden!");
// TODO: Indexinformation auslesen und auswerten!
  header("Content-Type: text/html; charset=utf-8");
  if ($time) header("Last-Modified: ".gmdate("D, d M Y H:i:s T",$time));	// andere Zeiten gibt's nicht
  echo "<!DOCTYPE html>\n";
  echo "<html><head>\n";
  echo "<base target=rechts>\n";
  echo "<link rel=stylesheet href='root/treeview.css'>\n";
  echo "</head><body>\n";
  echo "<div class='css-treeview'>\n";
  $ul=getdom($file,$trail);
  if ($key0=="hhc") $tree=recurse_hhc($ul);
  else $tree=generate_hhk($ul);
  out_tree($tree);
  echo "</div>\n";
  echo "</body></html>\n";
 }break;

 case "s": {
  header("Content-Type: text/plain");
  var_dump(systemfile($file));
 }break;
 
 case "hhp": {
  header("Content-Type: text/plain");
  hhp($file);
 }break;

 case "t": {	// Inhaltsverzeichnis (Hintertür) - ähnlich "ls"
  header("Content-Type: text/html");
  echo "<!DOCTYPE html>\n<pre>\n";
  $lines=lschm($file);
  foreach($lines as $line) {
   $i=strpos($line,"\t/");
   if ($i && substr($line,-1)!='/') {
    $i+=2;
    echo substr($line,0,$i);
    echo "<a href='".str_replace("#","%23",substr($line,$i))."'>";
    echo substr($line,$i);
    echo "</a>\n";
   }
  }
  echo "</pre>\n";
 }break;
 
 case "#": {
  LeftPane($info);
 }break;

 case "next":
 case "prev": {
  $a=getreferer();
  $url=substr($a['url'],0,$a['slash']+1).nextfile($file,$trail,$key0);
  if ($time) header("Last-Modified: ".gmdate("D, d M Y H:i:s T",$time));	// andere Zeiten gibt's nicht
  header("Location: $url");
 }break;

 default: if ($trail) {
  $mimetype=mimetype($trail);
  if ($mimetype) header("Content-Type: $mimetype");
  if ($time) header("Last-Modified: ".gmdate("D, d M Y H:i:s T",$time));	// andere Zeiten gibt's nicht
  unchm($file,$trail);
 }else{
  $sys=systemfile($file);
  header("Content-Type: text/html; charset=utf-8");
  if ($time) header("Last-Modified: ".gmdate("D, d M Y H:i:s T",$time));	// andere Zeiten gibt's nicht
  echo "<!DOCTYPE html>\n";
  echo "<html><head>\n";
  echo "<title>{$sys[3]}</title>\n";
  echo "</head><frameset cols='270,*'>\n";
  echo " <frame src='?%23' name=links>\n";	// HHC-Datei finden und konvertieren
  echo " <frame src='{$sys[2]}' name=rechts>\n";// Index-Datei finden und ausgeben
  echo "</frameset></html>\n";
 }
}


// Zeigt alle Informationen (Standardwert ist INFO_ALL)
// phpinfo();

// Zeigt nur die Modul-Informationen.
// phpinfo(8) führt zum gleichen Ergebnis.
//phpinfo(INFO_MODULES);
?>
